///////////////////////////////////////////////////////////////////////////////
//  Copyright (c) 2011 Sigma Designs, Inc.  All Rights Reserved.
//
// Pldevioctl.h
//
// Description:
//
//  PLV4LDEV ioctl interface
//
// History:
//	Jan 13, 2010	(dt) created
//
// Authors: (dt) David Tao
//
///////////////////////////////////////////////////////////////////////////////


#ifndef __C353_CTRL_H__
#define __C353_CTRL_H__

#ifndef _IOWR_BAD
#define _IOWR_BAD(type,nr,size)		_IOWR(type,nr,size)
#endif //!_IOWR_BAD

#define C353_STRM_IOCTL_BASE		4
#define C353_STRM_IOCTL_TYPE		'C'

/* deprecated */
#define ADV7604_EVENT_NO_SIGNAL         0
#define ADV7604_EVENT_TIMING_MATCH      1
#define ADV7604_EVENT_TIMING_NOMATCH    2

#define CH1_SIGNAL_CHANGED				(1L)
#define CH2_SIGNAL_CHANGED				(1L << 1)
#define CH1_SIGNAL_NO_LOCK				(1L << 2)
#define CH2_SIGNAL_NO_LOCK				(1L << 3)

#define C353_STRM_IOCTL_AUDIO_RATE		_IOWR_BAD(C353_STRM_IOCTL_TYPE, C353_STRM_IOCTL_BASE + 1, unsigned int)

enum audio_sample {
	RATE_32000,
	RATE_44100,
	RATE_48000,
	RATE_88200,
	RATE_96000,
	RATE_176400,
	RATE_192000,
};

#endif





