#include "plgpio.h"

int write_gpio(IHCIAPI *hci, int port, int val)
{
	EQP_Errors	qpStatus;
	TQP_UINT32	dwRegister;
	TQP_UINT32	dwMask;
	//TQP_BOOL gpio_val;

	//TQP_UINT32	dwGot = 0;
	dwMask = ~(1 << port);

	/* set gpio direction */
	qpStatus = QPHCI_RegisterRead(hci,
			0x610, &dwRegister);
	dwRegister = (dwRegister & dwMask) |
				 (GPIO_OUTPUT << port);
	QPHCI_RegisterWrite(hci,
			0x610, dwRegister);

	/* set gpio value */
	QPHCI_RegisterRead(hci,
			0x614, &dwRegister);
	dwRegister = (dwRegister & dwMask) | (val << port);

	qpStatus = QPHCI_RegisterWrite(hci,
		0x614, dwRegister);
    return qpStatus;
}

int read_gpio(IHCIAPI *hci, int port)
{
	EQP_Errors	qpStatus;
	TQP_UINT32	dwRegister;
	TQP_UINT32	dwMask;
	TQP_BOOL gpio_val;


	dwMask = ~(1 << port);
	qpStatus = QPHCI_RegisterRead(hci,
			0x610, &dwRegister);

	dwRegister = dwRegister & dwMask;

	qpStatus = !QP_SUCCESS(qpStatus) ?
		qpStatus : QPHCI_RegisterWrite(hci,
				0x610, dwRegister);

	qpStatus = QPHCI_RegisterRead(hci,
								  0x618,
								  &dwRegister
								  );
	gpio_val = (dwRegister >> port) & 1;

    return gpio_val;
}

int set_gpio_dir(IHCIAPI *hci, int port, GPIO_DIRECTION dir)
{
	EQP_Errors	qpStatus;
	TQP_UINT32	dwRegister;
	TQP_UINT32	dwMask;
	//TQP_BOOL gpio_val;

	qpStatus = QPHCI_RegisterRead(hci,
			0x610, &dwRegister);

	dwMask = ~(1 << port);
	dwRegister = (dwRegister & dwMask) |
				 (GPIO_INPUT << port);

	QPHCI_RegisterWrite(hci,
			0x610, dwRegister);
    return 0;
}

