#!/bin/bash

VDEV=0

if [ "$2" != "" ]; then
	VDEV=$2
fi

v4l2-ctl --device=/dev/video$VDEV --set-input=$1
v4l2-ctl --device=/dev/video$VDEV --set-fmt-video=width=0,height=0,pixelformat=MPEG

WIDTH=$(v4l2-ctl --device=/dev/video$VDEV -V|grep Width | awk '{print $3}' | cut -d '/' -f1)
HEIGHT=$(v4l2-ctl --device=/dev/video$VDEV -V|grep Width | awk '{print $3}' | cut -d '/' -f2)

../capture/capture --device=/dev/video$VDEV -o -c 0 | gst-launch-0.10 filesrc location=/dev/fd/0 ! \
	video/mpegts ! \
	mpegtsdemux name=demux ! \
	queue ! \
	video/x-h264 ! ffdec_h264 ! \
	"video/x-raw-yuv,width=$WIDTH,height=$HEIGHT,format=(fourcc)I420" ! \
	xvimagesink \
	demux. ! \
	queue ! aacparse ! faad ! alsasink
