#!/bin/bash

VDEV=0

if [ "$2" != "" ]; then
	VDEV=$2
fi

v4l2-ctl --device=/dev/video$VDEV --set-input=$1
v4l2-ctl --device=/dev/video$VDEV --set-fmt-video=width=0,height=0,pixelformat=YV12

WIDTH=$(v4l2-ctl --device=/dev/video$VDEV -V|grep Width | awk '{print $3}' | cut -d '/' -f1)
HEIGHT=$(v4l2-ctl --device=/dev/video$VDEV -V|grep Width | awk '{print $3}' | cut -d '/' -f2)

gst-launch-0.10 v4l2src device=/dev/video$VDEV ! \
	"video/x-raw-yuv,width=$WIDTH,height=$HEIGHT,format=(fourcc)YV12" ! \
	timeoverlay halign=left valign=bottom text="time:" ! \
	queue ! \
	vaapiupload ! \
	vaapisink
