///////////////////////////////////////////////////////////////////////////////
//  Copyright (c) 2011 Sigma Designs, Inc.  All Rights Reserved.   
//
// Peripherals.c
//
// Description: 
//
//  Peripheral and USB init/done functions
// 
// History:
//	Sep 14, 2006 (dt) created
//
// Authors: (dt) David Tao
//
///////////////////////////////////////////////////////////////////////////////

#if defined(QP_LINXKER)
#include "qlautoconf.h"
#endif
#include "cqlcodeclib.h"
//#include "util.h"

#ifdef _QPCODEC_PURE


TQP_BOOL CQLCodecLib_CreatePCIe(CQLCodecLib *This)
{
	return (QP_TRUE);
}



void CQLCodecLib_DeletePCIe(CQLCodecLib *This)
{
}



EQP_Errors CQLCodecLib_InitPCIe(CQLCodecLib *This)
{
	return (QPERR_SUCCESS);
}



void CQLCodecLib_DonePCIe(CQLCodecLib *This)
{
}



TQP_BOOL CQLCodecLib_CreatePeripherals(CQLCodecLib *This)
{
	return (QP_TRUE);
}



void CQLCodecLib_DeletePeripherals(CQLCodecLib *This)
{
}



EQP_Errors CQLCodecLib_InitPeripherals(CQLCodecLib *This)
{
	return (QPERR_SUCCESS);
}



void CQLCodecLib_DonePeripherals(CQLCodecLib *This)
{
}

#else //!_QPCODEC_PURE

#include "qpdbgmgr.h"
#include "qpmemmgr.h"
#if !defined(CONFIG_HOST_PLATFORM_PL330SOC)

#include "cgv7601.h"
#include "cadv7604.h"
#include "tlv320aic3101.h"
#include "boardinfo-probe.h"
#include "peripherals.h"
#endif
#if defined(CONFIG_HOST_PLATFORM_PL330SOC)
#if defined (CONFIG_QL300_AVIU_NATIVE_NT99240)
#include "cvidinputnativent99240.h"
#else
#include "cvidinputnativemi2010.h"
#endif
#endif


//extern EQP_Errors CADV7604_Create(CQLCodecLib* This ,Chip_Cfg * chip_cfg);
//extern void CADV7604_Delete(CQLCodecLib* This);
//extern EQP_Errors CGV7601_Create(CQLCodecLib* This ,Chip_Cfg * chip_cfg);
//extern void CGV7601_Delete(CQLCodecLib* This);
//extern EQP_Errors CAIC3101_Create(CQLCodecLib* This ,Chip_Cfg * chip_cfg);
//extern void CAIC3101_Delete(CQLCodecLib* This);
/////////////////////////////////////////////////////////////////////////////
//
//



#if 10 
typedef EQP_Errors (*Peripheral_Create)(CQLCodecLib* ,Chip_Cfg * );
typedef void (*Peripheral_Delete)(CQLCodecLib*);
typedef struct _Peripherals_Lib{
    Peripheral_Create create;
    Peripheral_Delete delete;
}Peripherals_Lib;

static Peripherals_Lib peripherals_lib[PERIPHERALS_MAX]={
    [VIDEO_7601]={
        .create = CGV7601_Create,
        .delete = CGV7601_Delete,
    }, [VIDEO_7604] = {
        .create = CADV7604_Create,
        .delete = CADV7604_Delete,
    }, [AUDIO_TI3101] = {
        .create = CAIC3101_Create,
        .delete = CAIC3101_Delete,
    },
};
TQP_BOOL Create_Audio_Dummy(CQLCodecLib *This)
{
    CAudioCodec		*pAudCodec;

    pAudCodec = (CAudioCodec *)QPMMMalloc2Ex(sizeof(CAudioCodec));

    if (!pAudCodec)
    {
        QPDbgMPrintf((QPDBGMCOMPLVL(g_QPCodecDBGCompID, QPDBGM_LEVEL_ERROR),
                    "CQLCodecLib_CreatePeripherals() pAudCodec == NULL!!!\n"
                    ));
        return (QP_FALSE);
    }

    This->m_pAudCodec = CAudioCodec_Constructor(pAudCodec,
            &This->m_Object,
            OBJECT_DEFAULT
            );

    if (QP_NULL == This->m_pAudCodec)
    {
        QPDbgMPrintf((QPDBGMCOMPLVL(g_QPCodecDBGCompID, QPDBGM_LEVEL_ERROR),
                    "CQLCodecLib_CreatePeripherals() CAudioCodec_Constructor() failed\n"
                    ));
        QPMMFree2Ex(pAudCodec);
        return (QP_FALSE);
    }
    return QP_TRUE;
}
void Delete_Audio_Dummy(CQLCodecLib *This)
{
    if(This->m_pAudCodec)
    {
        CAudioCodec_Destructor(This->m_pAudCodec);
        QPMMFree2Ex(This->m_pAudCodec);
        This->m_pAudCodec = QP_NULL;

    }
}


TQP_BOOL Create_Video_Decoder_Dummy(CQLCodecLib *This)
{
    CVideoDecoder	*pVidDecoder;

    pVidDecoder = (CVideoDecoder *)QPMMMalloc2Ex(sizeof(CVideoDecoder));
    if (!pVidDecoder)
    {
        QPDbgMPrintf((QPDBGMCOMPLVL(g_QPCodecDBGCompID, QPDBGM_LEVEL_ERROR),
                    "CQLCodecLib_CreatePeripherals() pVidDecoder == NULL!!!\n"
                    ));
        return (QP_FALSE);
    }

    This->m_pVidDecoder = (CVideoDecoder *)CVideoDecoder_Constructor(pVidDecoder, 
            &This->m_Object,
            OBJECT_DEFAULT
            );
    if (QP_NULL == This->m_pVidDecoder)
    {
        QPDbgMPrintf((QPDBGMCOMPLVL(g_QPCodecDBGCompID, QPDBGM_LEVEL_ERROR),
                    "CQLCodecLib_CreatePeripherals() CVideoDecoder_Constructor() failed\n"
                    ));
        QPMMFree2Ex(pVidDecoder);
        return (QP_FALSE);
    }
    return QP_TRUE;
}
void Delete_Video_Decoder_Dummy(CQLCodecLib *This)
{
    if(This->m_pVidDecoder)
    {
        CVideoDecoder_Destructor(This->m_pVidDecoder);
        QPMMFree2Ex(This->m_pVidDecoder);
        This->m_pVidDecoder = QP_NULL; 
    }
}




TQP_BOOL CQLCodecLib_Create_Peripherals_By_Probe(CQLCodecLib* This)
{
    Chip_Cfg * chip_cfg = QP_NULL;
    PL330_boards_info *board_info = &This->m_InitData.board_info;
    //int video_init=0, audio_init=0;
    //LOG("board_name = %s",board_info->boardname);
    for(chip_cfg=board_info->device_cfg ; chip_cfg->name != QP_NULL ; chip_cfg++)
    {
        //LOG("name = %s",chip_cfg->name);
        //LOG_NUM(chip_cfg->peripheral_type);
        if(peripherals_lib[chip_cfg->peripheral_type].create(This,chip_cfg) != QPERR_SUCCESS)
        {
            //LOG("peripherals_lib[%d].create(This,chip_cfg) fail",chip_cfg->peripheral_type);
            return QP_FALSE;
        }
        //LOG_HEX(chip_cfg->device_set);
    }
    if(!This->m_pVidDecoder)
    {
        if(Create_Video_Decoder_Dummy(This) != QP_TRUE)
        {
            return QP_FALSE;
        }
    }
    if(!This->m_pAudCodec)
    {
        if(Create_Audio_Dummy(This) != QP_TRUE)
        {
            return QP_FALSE;
        }
    }
    return QP_TRUE;
}

void CQLCodecLib_Delete_Peripheral_By_Probe(CQLCodecLib* This)
{
    Chip_Cfg * chip_cfg = QP_NULL;
    PL330_boards_info *board_info = &This->m_InitData.board_info;
    for(chip_cfg=board_info->device_cfg ; chip_cfg->name != QP_NULL ; chip_cfg++)
    {
        peripherals_lib[chip_cfg->peripheral_type].delete(This); 
    }
    Delete_Video_Decoder_Dummy(This);
    Delete_Audio_Dummy(This);
}
#if 0
static EQP_Errors CQLCodecLib_Create_Peripherals_By_Probe(CQLCodecLib* This)
{
    Chip_Cfg * chip_cfg = NULL;
    struct PL330_boards_info *board_info = This->m_InitData.board_info;
    int video_init=0, audio_init=0;
    for(chip_cfg=board_info->device_cfg ; *chip_cfg->name ; chip_cfg++)
    {
        peripherals_lib[chip_cfg->peripheral_type].create(This,chip_cfg); 
        if(chip_cfg->peripheral_type && VIDEO_CLASS)
        {
            video_init = 1;
        }
        if(chip_cfg->peripheral_type && AUDIO_CLASS)
        {
            audio_init = 1;
        }
    }
    if(!video_init)
    {
        if(Create_Video_Decoder_Dummy(This) != QPERR_SUCCESS)
        {
            return QP_FALSE;
        }
    }
    if(!audio_init)
    {
        if(Create_Audio_Dummy(This) != QPERR_SUCCESS)
        {
            return QP_FALSE;
        }
    }


}
static EQP_Errors CQLCodecLib_Delete_Peripheral_By_Probe(CQLCodecLib* This)
{
    Chip_Cfg * chip_cfg = NULL;
    struct PL330_boards_info *board_info = This->m_InitData.board_info;
    int video_delete=0, audio_delete=0;
    for(chip_cfg=board_info->device_cfg ; *chip_cfg->name ; chip_cfg++)
    {
        peripherals_lib[chip_cfg->peripheral_type].create(This,chip_cfg); 
        if(chip_cfg->peripheral_type && VIDEO_CLASS)
        {
            video_delete = 1;
        }
        if(chip_cfg->peripheral_type && AUDIO_CLASS)
        {
            audio_delete = 1;
        }
    }
    if(!video_delete)
    {
        Delete_Video_Decoder_Dummy(This);
    }
    if(!audio_delete)
    {
        Delete_Audio_Dummy(This);
    }
}
#endif

#endif

static EQP_Errors CQLCodecLibBusCallback(TQP_PVOID Context, 
										 TQP_UINT32 dwCode, 
										 TQP_PVOID pParam
										 )
{
	CQLCodecLib	*pQLCodecLib = (CQLCodecLib	*)Context;

	if (pQLCodecLib &&
		pQLCodecLib->m_pMpgCodec
		) 
	{
		switch (dwCode)
		{
			case QPBUSINTF_ARM_INT:
				QPOSMSetEvtgrp(pQLCodecLib->m_pMpgCodec->m_EvtTask, 
							   QLCODEC_EVENT_ARM_INT
							   );
				break;

			case QPBUSINTF_DMA_READ_DONE:
				QPOSMSetEvtgrp(pQLCodecLib->m_pMpgCodec->m_EvtTask, 
							   QLCODEC_EVENT_DMA_READ_DONE
							   );
				QPOSMSetEvtgrp(pQLCodecLib->m_pMpgCodec->m_EvtSyncDma, 
							   QLCODEC_EVENT_DMA_SYNC_READ_DONE
							   );
				break;

			case QPBUSINTF_DMA_WRITE_DONE:
				QPOSMSetEvtgrp(pQLCodecLib->m_pMpgCodec->m_EvtTask,
							   QLCODEC_EVENT_DMA_WRITE_DONE
							   );
				QPOSMSetEvtgrp(pQLCodecLib->m_pMpgCodec->m_EvtSyncDma,
							   QLCODEC_EVENT_DMA_SYNC_WRITE_DONE
							   );
				break;

			default:
				break;
		}
	}

	return (QPERR_SUCCESS);
}


TQP_BOOL CQLCodecLib_CreatePCIe(CQLCodecLib *This)
{
	CPCIeCntl	*pPCIeInterface;

	// create PCIe bus interafce
	//
	pPCIeInterface = (CPCIeCntl *)QPMMMalloc2Ex(sizeof(CPCIeCntl));
	if (!pPCIeInterface)
	{
		QPDbgMPrintf((QPDBGMCOMPLVL(g_QPCodecDBGCompID, QPDBGM_LEVEL_ERROR),
					 "CQLCodecLib_CreateInitPCIe() pPCIeInterface == NULL!!!\n"
					 ));
		return (QP_FALSE);
	}

	This->m_pPCIeCntl = CPCIeCntl_Constructor(pPCIeInterface, 
											  &This->m_Object,
											  OBJECT_CRITICAL_LIGHT, 
											  This->m_pDO, 
											  This->m_PDOLayered,
											  CQLCodecLibBusCallback,
											  This
											  );
	if (!This->m_pPCIeCntl)
	{
		QPDbgMPrintf((QPDBGMCOMPLVL(g_QPCodecDBGCompID, QPDBGM_LEVEL_ERROR),
					 "CQLCodecLib_CreateInitPCIe() CPCIeCntl_Constructor() failed\n"
					 ));
		QPMMFree2Ex(pPCIeInterface);
		return (QP_FALSE);
	}

	return (QP_TRUE);
}



void CQLCodecLib_DeletePCIe(CQLCodecLib *This)
{
	// delete PCIe bus interface
	//
	if (This->m_pPCIeCntl)
	{
		CPCIeCntl_Destructor(This->m_pPCIeCntl);
		QPMMFree2Ex(This->m_pPCIeCntl);
		This->m_pPCIeCntl = QP_NULL;
	}
}




EQP_Errors CQLCodecLib_InitPCIe(CQLCodecLib *This)
{
	EQP_Errors	qpStatus = QPERR_SUCCESS;

	// initialize PCIe bus interface
	//
	if (This->m_pPCIeCntl)
	{
		qpStatus = QPGenericDevice_InitDevice(This->m_pPCIeCntl, 
											  QP_NULL,
											  QP_NULL,
											  (TQP_PVOID)&This->m_InitData.mpgCodecInitData
											  );

		if (!QP_SUCCESS(qpStatus))
		{
			QPDbgMPrintf((QPDBGMCOMPLVL(g_QPCodecDBGCompID, QPDBGM_LEVEL_ERROR),
						 "CQLCodecLib_InitPCIe() m_pPCIeCntl->InitDevice Failed status(0x%x)!!!\n",
						 qpStatus
						 ));
		}
	}

	return (qpStatus);
}



void CQLCodecLib_DonePCIe(CQLCodecLib *This)
{
	// delete PCIe bus interface
	//
	if (This->m_pPCIeCntl)
	{
		QPGenericDevice_Release(This->m_pPCIeCntl);
	}
}


TQP_BOOL CQLCodecLib_CreatePeripheralsAudCodec(CQLCodecLib *This)
{

	CAudioCodec		*pAudCodec;
	// create audio codec
	//
	switch (This->m_InitData.audCodecInitData.type)
	{
		case AUDCODEC_DUMMY:
			pAudCodec = (CAudioCodec *)QPMMMalloc2Ex(sizeof(CAudioCodec));

			if (!pAudCodec)
			{
				QPDbgMPrintf((QPDBGMCOMPLVL(g_QPCodecDBGCompID, QPDBGM_LEVEL_ERROR),
							 "CQLCodecLib_CreatePeripherals() pAudCodec == NULL!!!\n"
							 ));
				return (QP_FALSE);
			}

			This->m_pAudCodec = CAudioCodec_Constructor(pAudCodec,
														&This->m_Object,
														OBJECT_DEFAULT
														);

			if (QP_NULL == This->m_pAudCodec)
			{
				QPDbgMPrintf((QPDBGMCOMPLVL(g_QPCodecDBGCompID, QPDBGM_LEVEL_ERROR),
							 "CQLCodecLib_CreatePeripherals() CAudioCodec_Constructor() failed\n"
							 ));
				QPMMFree2Ex(pAudCodec);
				return (QP_FALSE);
			}
			break;


#if !defined(CONFIG_HOST_PLATFORM_PL330SOC)
		case AUDCODEC_AIC3101:
			pAudCodec = (CAudioCodec *)QPMMMalloc2Ex(sizeof(CAIC3101));

			if (!pAudCodec)
			{
				QPDbgMPrintf((QPDBGMCOMPLVL(g_QPCodecDBGCompID, QPDBGM_LEVEL_ERROR),
							 "CQLCodecLib_CreatePeripherals() pAudCodec == NULL!!!\n"
							 ));
				return (QP_FALSE);
			}

			This->m_pAudCodec = (CAudioCodec *) CAIC3101_Constructor((CAIC3101 *)pAudCodec,
														&This->m_Object,
														OBJECT_DEFAULT,
														I_I2C(This),
														AIC3101_DEVICE_ADDR
														);

			if (QP_NULL == This->m_pAudCodec)
			{
				QPDbgMPrintf((QPDBGMCOMPLVL(g_QPCodecDBGCompID, QPDBGM_LEVEL_ERROR),
							 "CQLCodecLib_CreatePeripherals() CFM31_Constructor() failed\n"
							 ));
				QPMMFree2Ex(pAudCodec);
				return (QP_FALSE);
			}
			break;
#endif

		default:
			break;
	}
	return (QP_TRUE);
}

// Andy 2008.10.14: create video decoder
TQP_BOOL CQLCodecLib_CreatePeripheralsVidDecoder(CQLCodecLib *This)
{
	CVideoDecoder	*pVidDecoder;

	QPDbgMPrintf((QPDBGMCOMPLVL(g_QPCodecDBGCompID, QPDBGM_LEVEL_WARN),
				 "%s(): type(%d) multiType(%d)\n",
				 __FUNCTION__,
				 This->m_InitData.vidDecoderInitData.type,
				 This->m_InitData.vidDecoderInitData.multiType
				 ));

	// create video decoder
	//
	switch (This->m_InitData.vidDecoderInitData.type)
	{
		case VIDDECODER_DUMMY:
			pVidDecoder = (CVideoDecoder *)QPMMMalloc2Ex(sizeof(CVideoDecoder));
			if (!pVidDecoder)
			{
				QPDbgMPrintf((QPDBGMCOMPLVL(g_QPCodecDBGCompID, QPDBGM_LEVEL_ERROR),
							 "CQLCodecLib_CreatePeripherals() pVidDecoder == NULL!!!\n"
							 ));
				return (QP_FALSE);
			}

			This->m_pVidDecoder = (CVideoDecoder *)CVideoDecoder_Constructor(pVidDecoder, 
																			 &This->m_Object,
																			 OBJECT_DEFAULT
																			 );
			if (QP_NULL == This->m_pVidDecoder)
			{
				QPDbgMPrintf((QPDBGMCOMPLVL(g_QPCodecDBGCompID, QPDBGM_LEVEL_ERROR),
							 "CQLCodecLib_CreatePeripherals() CVideoDecoder_Constructor() failed\n"
							 ));
				QPMMFree2Ex(pVidDecoder);
				return (QP_FALSE);
			}
			break;

			
#if !defined(CONFIG_HOST_PLATFORM_PL330SOC)
		case VIDDECODER_ADV7604:
			pVidDecoder = (CVideoDecoder *)QPMMMalloc2Ex(sizeof(CADV7604));
			if (!pVidDecoder)
			{
				QPDbgMPrintf((QPDBGMCOMPLVL(g_QPCodecDBGCompID, QPDBGM_LEVEL_ERROR),
							 "CQLCodecLib_CreatePeripherals() pVidDecoder == NULL!!!\n"
							 ));
				return (QP_FALSE);
			}

			This->m_pVidDecoder = (CVideoDecoder *)CADV7604_Constructor((CADV7604 *)pVidDecoder, 
																	    &This->m_Object,
																	    OBJECT_DEFAULT,
																	    I_I2C(This),
																	    ADV7604_DEVICE_ADDR_IO
																	    );
			if (QP_NULL == This->m_pVidDecoder)
			{
				QPDbgMPrintf((QPDBGMCOMPLVL(g_QPCodecDBGCompID, QPDBGM_LEVEL_ERROR),
							 "CQLCodecLib_CreatePeripherals() CADV7604_Constructor() failed\n"
							 ));
				QPMMFree2Ex(pVidDecoder);
				return (QP_FALSE);
			}
			break;
#endif

#if !defined(CONFIG_HOST_PLATFORM_PL330SOC)
		case VIDDECODER_GV7601:
			pVidDecoder = (CVideoDecoder *)QPMMMalloc2Ex(sizeof(CGV7601));
			if (!pVidDecoder)
			{
				QPDbgMPrintf((QPDBGMCOMPLVL(g_QPCodecDBGCompID, QPDBGM_LEVEL_ERROR),
							 "CQLCodecLib_CreatePeripherals() pVidDecoder == NULL!!!\n"
							 ));
				return (QP_FALSE);
			}

			This->m_pVidDecoder = (CVideoDecoder *)CGV7601_Constructor((CGV7601 *)pVidDecoder, 
																	    &This->m_Object,
																	    OBJECT_DEFAULT,
																	    I_I2C(This),
																	    0
																	    );
			if (QP_NULL == This->m_pVidDecoder)
			{
				QPDbgMPrintf((QPDBGMCOMPLVL(g_QPCodecDBGCompID, QPDBGM_LEVEL_ERROR),
							 "CQLCodecLib_CreatePeripherals() CGV7601_Constructor() failed\n"
							 ));
				QPMMFree2Ex(pVidDecoder);
				return (QP_FALSE);
			}
			break;
#endif


		default:
			break;
	}

	return (QP_TRUE);
}



TQP_BOOL CQLCodecLib_CreatePeripherals(CQLCodecLib *This) 
{
	CI2C			*pI2CProvider;
	CVideoEncoder	*pVidEncoder;
	CTuner			*pTuner;
	CTVAudio		*pTVAudio;


	// create I2C provider
	//
	pI2CProvider = (CI2C *)QPMMMalloc2Ex(sizeof(CI2C));

	if (!pI2CProvider)
	{
		QPDbgMPrintf((QPDBGMCOMPLVL(g_QPCodecDBGCompID, QPDBGM_LEVEL_ERROR),
					 "CQLCodecLib_CreatePeripherals() pI2CProvider == NULL!!!\n"
					 ));
		return (QP_FALSE);
	}

	This->m_pI2CProvider = CI2C_Constructor(pI2CProvider, 
											&This->m_Object,
											OBJECT_DEFAULT,
											This->m_InitData.i2cInitData.type,
											This->m_InitData.i2cInitData.clk,
											This->m_InitData.i2cInitData.data,
											This->m_pMpgCodec
											);
	if (QP_NULL == This->m_pI2CProvider)
	{
		QPDbgMPrintf((QPDBGMCOMPLVL(g_QPCodecDBGCompID, QPDBGM_LEVEL_ERROR),
					 "CQLCodecLib_CreatePeripherals() CI2C init failed\n"
					 ));
		QPMMFree2Ex(pI2CProvider);
		return (QP_FALSE);
	}

	// create extend I2C provider
	//
	pI2CProvider = (CI2C *)QPMMMalloc2Ex(sizeof(CI2C));

	if (!pI2CProvider)
	{
		QPDbgMPrintf((QPDBGMCOMPLVL(g_QPCodecDBGCompID, QPDBGM_LEVEL_ERROR),
					 "CQLCodecLib_CreatePeripherals() pI2CProviderEx == NULL!!!\n"
					 ));
		return (QP_FALSE);
	}


	This->m_pI2CProviderEx = CI2C_Constructor(pI2CProvider,
											&This->m_Object,
											OBJECT_DEFAULT,
											This->m_InitData.i2cInitDataEx.type,
											This->m_InitData.i2cInitDataEx.clk,
											This->m_InitData.i2cInitDataEx.data,
											This->m_pMpgCodec
											);
	if (QP_NULL == This->m_pI2CProviderEx)
	{
		QPDbgMPrintf((QPDBGMCOMPLVL(g_QPCodecDBGCompID, QPDBGM_LEVEL_ERROR),
					 "CQLCodecLib_CreatePeripherals() CI2CEx init failed\n"
					 ));
		QPMMFree2Ex(pI2CProvider);
		return (QP_FALSE);
	}


	// create tv tuner
	//
	switch (This->m_InitData.tunerInitData.type)
	{
		case TUNER_DUMMY:
			pTuner = (CTuner *)QPMMMalloc2Ex(sizeof(CTuner));

			if (!pTuner)
			{
				QPDbgMPrintf((QPDBGMCOMPLVL(g_QPCodecDBGCompID, QPDBGM_LEVEL_ERROR),
							 "CQLCodecLib_CreatePeripherals() pTuner == NULL!!!\n"
							 ));
				return (QP_FALSE);
			}

			This->m_pTuner = CTuner_Constructor(pTuner,
												&This->m_Object,
												OBJECT_DEFAULT
												);
			if (QP_NULL == This->m_pTuner)
			{
				QPDbgMPrintf((QPDBGMCOMPLVL(g_QPCodecDBGCompID, QPDBGM_LEVEL_ERROR),
							 "CQLCodecLib_CreatePeripherals() CTuner_Constructor failed!!!\n" 
							 ));
				QPMMFree2Ex((void *)pTuner);
				return (QP_FALSE);
			}
			break;

		default:
			break;
	}

	// create tv Audio
	//
	switch (This->m_InitData.tvAudioInitData.type)
	{
		case TVAUDIO_DUMMY:
			pTVAudio = (CTVAudio *)QPMMMalloc2Ex(sizeof(CTVAudio));

			if (!pTVAudio)
			{
				QPDbgMPrintf((QPDBGMCOMPLVL(g_QPCodecDBGCompID, QPDBGM_LEVEL_ERROR),
							 "CQLCodecLib_CreatePeripherals() pTVAudio == NULL!!!\n"
							 ));
				return (QP_FALSE);
			}

			This->m_pTVAudio = CTVAudio_Constructor(pTVAudio,
													&This->m_Object,
													OBJECT_DEFAULT
													);
			if (QP_NULL == This->m_pTVAudio)
			{
				QPDbgMPrintf((QPDBGMCOMPLVL(g_QPCodecDBGCompID, QPDBGM_LEVEL_ERROR),
							 "CQLCodecLib_CreatePeripherals() CTVAudio_Constructor() failed!!!\n" 
							 ));
				QPMMFree2Ex((void *)pTVAudio);
				return (QP_FALSE);
			}
			break;

		default:
			break;
	}


	// create video encoder
	//
	switch (This->m_InitData.vidEncoderInitData.type)
	{
		case VIDENCODER_DUMMY:
			pVidEncoder = (CVideoEncoder *)QPMMMalloc2Ex(sizeof(CVideoEncoder));
			if (!pVidEncoder)
			{
				QPDbgMPrintf((QPDBGMCOMPLVL(g_QPCodecDBGCompID, QPDBGM_LEVEL_ERROR),
							 "CQLCodecLib_CreatePeripherals() pVidEncoder == NULL!!!\n"
							 ));
				return (QP_FALSE);
			}

			This->m_pVidEncoder = (CVideoEncoder *)CVideoEncoder_Constructor(pVidEncoder, 
																			 &This->m_Object,
																			 OBJECT_DEFAULT
																			 );
			if (QP_NULL == This->m_pVidEncoder)
			{
				QPDbgMPrintf((QPDBGMCOMPLVL(g_QPCodecDBGCompID, QPDBGM_LEVEL_ERROR),
							 "CQLCodecLib_CreatePeripherals() CVideoEncoder_Constructor() failed\n"
							 ));
				QPMMFree2Ex(pVidEncoder);
				return (QP_FALSE);
			}
			break;


		default:
			break;
	}
    #if 0
    if(!CQLCodecLib_CreatePeripheralsAudCodec(This))
    {
        LOG("QLCodecLib_CreatePeripheralsAudCodec fail"); 
				return (QP_FALSE);
    }
    #endif

	return (QP_TRUE);
}



// Andy 2008.10.14: delete video decoder
void CQLCodecLib_DeletePeripheralsVidDecoder(CQLCodecLib *This)
{
	if (This->m_pVidDecoder)
	{
		switch (This->m_InitData.vidDecoderInitData.type)
		{
			case VIDDECODER_DUMMY:
				CVideoDecoder_Destructor(This->m_pVidDecoder);
				break;
#if !defined(CONFIG_HOST_PLATFORM_PL330SOC)
			case VIDDECODER_ADV7604:
				CADV7604_Destructor((CADV7604 *)This->m_pVidDecoder);
				break;
			case VIDDECODER_GV7601:
				CGV7601_Destructor((CGV7601 *)This->m_pVidDecoder);
				break;
#endif
				
			default:
				break;
		}

		QPMMFree2Ex(This->m_pVidDecoder);
		This->m_pVidDecoder = QP_NULL;
	}
}



void CQLCodecLib_DeletePeripherals(CQLCodecLib *This)
{
	// delete all the objects we created during Init()
	//
    /*
	if (This->m_pAudCodec)
	{
		switch (This->m_InitData.audCodecInitData.type)
		{
			case AUDCODEC_DUMMY:
				CAudioCodec_Destructor(This->m_pAudCodec);
				break;

			default:
				break;
		}

		QPMMFree2Ex(This->m_pAudCodec);
		This->m_pAudCodec = QP_NULL;
	}
    */
    CQLCodecLib_Delete_Peripheral_By_Probe(This);
	if (This->m_pVidEncoder)
	{
		switch (This->m_InitData.vidEncoderInitData.type)
		{
			case VIDENCODER_DUMMY:
				CVideoEncoder_Destructor(This->m_pVidEncoder);
				break;

			default:
				break;
		}

		QPMMFree2Ex(This->m_pVidEncoder);
		This->m_pVidEncoder = QP_NULL;
	}

	//CQLCodecLib_DeletePeripheralsVidDecoder(This);

	if (This->m_pTVAudio)
	{
		switch (This->m_InitData.tvAudioInitData.type)
		{
			case TVAUDIO_DUMMY:
				CTVAudio_Destructor(This->m_pTVAudio);
				break;

			default:
				break;
		}

		QPMMFree2Ex(This->m_pTVAudio);
		This->m_pTVAudio = QP_NULL;
	}

	if (This->m_pTuner)
	{
		switch (This->m_InitData.tunerInitData.type)
		{
			case TUNER_DUMMY:
				CTuner_Destructor(This->m_pTuner);
				break;

			default:
				break;
		}

		QPMMFree2Ex(This->m_pTuner);
		This->m_pTuner = QP_NULL;
	}

	if (This->m_pI2CProviderEx)
	{
		CI2C_Destructor(This->m_pI2CProviderEx);
		QPMMFree2Ex(This->m_pI2CProviderEx);
		This->m_pI2CProviderEx = QP_NULL;
	}

	if (This->m_pI2CProvider)
	{
		CI2C_Destructor(This->m_pI2CProvider);
		QPMMFree2Ex(This->m_pI2CProvider);
		This->m_pI2CProvider = QP_NULL;
	}
}



// Andy 2008.10.14: initialize video decoder
EQP_Errors CQLCodecLib_InitPeripheralsVidDecoder(CQLCodecLib *This)
{
	EQP_Errors	qpStatus = QPERR_SUCCESS;

	// initialize video decoder
	//
	if (This->m_pVidDecoder)
	{
		qpStatus = QPGenericDevice_InitDevice(I_VIDDECODER(This), 
											  This->m_pDeviceCallback,
											  This->m_callbackContext,
											  (TQP_PVOID)&This->m_InitData.vidDecoderInitData
											  );

		if (!QP_SUCCESS(qpStatus))
		{
			QPDbgMPrintf((QPDBGMCOMPLVL(g_QPCodecDBGCompID, QPDBGM_LEVEL_ERROR),
						 "CQLCodecLib_InitDevice() m_pVidDecoder->InitDevice Failed status(%d)!!!\n",
						 qpStatus
						 ));
		}
	}

	return (qpStatus);
}



EQP_Errors CQLCodecLib_InitPeripherals(CQLCodecLib *This)
{
	EQP_Errors	qpStatus = QPERR_SUCCESS;

	// initialize video decoder
	//
	qpStatus = CQLCodecLib_InitPeripheralsVidDecoder(This);
	if (!QP_SUCCESS(qpStatus))
	{
		return (qpStatus);
	}

	// initialize video encoder
	//
	if (This->m_pVidEncoder)
	{
		qpStatus = QPGenericDevice_InitDevice(I_VIDENCODER(This),
											  This->m_pDeviceCallback,
											  This->m_callbackContext,
											  (TQP_PVOID)&This->m_InitData.vidEncoderInitData
											  );

		if (!QP_SUCCESS(qpStatus))
		{
			QPDbgMPrintf((QPDBGMCOMPLVL(g_QPCodecDBGCompID, QPDBGM_LEVEL_ERROR),
						 "CQLCodecLib_InitDevice() m_pVidEncoder->InitDevice Failed status(%d)!!!\n",
						 qpStatus
						 ));
			return (qpStatus);
		}
	}

	// initialize tuner
	//
	if (This->m_pTuner)
	{
		qpStatus = QPGenericDevice_InitDevice(I_TUNER(This), 
											  This->m_pDeviceCallback,
											  This->m_callbackContext,
											  (TQP_PVOID)&This->m_InitData.tunerInitData
											  );
		if (!QP_SUCCESS(qpStatus))
		{
			QPDbgMPrintf((QPDBGMCOMPLVL(g_QPCodecDBGCompID, QPDBGM_LEVEL_ERROR),
						 "CQLCodecLib_InitDevice() m_pTuner->InitDevice Failed status(%d)!!!\n",
						 qpStatus
						 ));
			return (qpStatus);
		}
	}

	// initialize tvaudio
	//
	if (This->m_pTVAudio)
	{
		qpStatus = QPGenericDevice_InitDevice(I_TVAUDIO(This),
											  This->m_pDeviceCallback,
											  This->m_callbackContext,
											  (TQP_PVOID)&This->m_InitData.tvAudioInitData
											  );
		if (!QP_SUCCESS(qpStatus))
		{
			QPDbgMPrintf((QPDBGMCOMPLVL(g_QPCodecDBGCompID, QPDBGM_LEVEL_ERROR),
						 "CQLCodecLib_InitDevice() m_pTVAudio->InitDevice Failed status(%d)!!!\n",
						 qpStatus
						 ));
			return (qpStatus);
		}
	}

	// initialize audio codec
	//
	if (This->m_pAudCodec)
	{
		qpStatus = QPGenericDevice_InitDevice(I_AUDCODEC(This),
											  This->m_pDeviceCallback,
											  This->m_callbackContext,
											  (TQP_PVOID)&This->m_InitData.audCodecInitData
											  );
		if (!QP_SUCCESS(qpStatus))
		{
			QPDbgMPrintf((QPDBGMCOMPLVL(g_QPCodecDBGCompID, QPDBGM_LEVEL_ERROR),
						 "CQLCodecLib_InitDevice() m_pAudCodec->InitDevice Failed status(%d)!!!\n",
						 qpStatus
						 ));
			return (qpStatus);
		}
	}

	return (qpStatus);
}



// Andy 2008.10.14: release video decoder
void CQLCodecLib_DonePeripheralsVidDecoder(CQLCodecLib *This)
{
	if (This->m_pVidDecoder)
		QPGenericDevice_Release(I_VIDDECODER(This));
}



void CQLCodecLib_DonePeripherals(CQLCodecLib *This)
{
	if (This->m_pAudCodec)
		QPGenericDevice_Release(I_AUDCODEC(This));

	if (This->m_pTVAudio)
		QPGenericDevice_Release(I_TVAUDIO(This));

	if (This->m_pTuner)
		QPGenericDevice_Release(I_TUNER(This));

	if (This->m_pVidEncoder)
		QPGenericDevice_Release(I_VIDENCODER(This));

	CQLCodecLib_DonePeripheralsVidDecoder(This);
}



#endif //_QPCODEC_PURE
