#ifndef __PL330_DBG_H__
#define __PL330_DBG_H__

/* Debugging level */
#define PL330_TRACE_PROBE		(1 << 0)
#define PL330_TRACE_VID			(1 << 1)
#define PL330_TRACE_CALL		(1 << 2)
#define PL330_TRACE_IOCTL		(1 << 3)
#define PL330_TRACE_STATS		(1 << 4)
#define PL330_TRACE_VIDEO		(1 << 5)
#define PL330_TRACE_PORT		(1 << 6)
#define PL330_TRACE_VIDIOC		(1 << 7)
#define PL330_TRACE_SND			(1 << 8)
#define PL330_TRACE_PCM			(1 << 9)

/* check H264 pixel format is defined
 * no defined under kernel 3.1
 */
#ifndef V4L2_PIX_FMT_H264
#define V4L2_PIX_FMT_H264		v4l2_fourcc('H', '2', '6', '4')
#endif

extern unsigned int pl330_trace_param;

#define pl330_trace(flag, msg...) \
	do { \
		if(pl330_trace_param & flag) \
			printk("pl330: " msg); \
	} while(0)

#define pl330_printk(level, msg...) \
	printk(level "pl330: " msg)

#endif
